


#include <p18f4550.h>

#include "h/MemorisationsEEPROM.h"
#include "h/Parametres.h"
#include "h/Utilitaires.h"



unsigned char EERead(unsigned char ad)
{
	EECON1bits.EEPGD = 0;
	EECON1bits.CFGS = 0;
	EEADR = ad;
	EECON1bits.RD = 1;

	return EEDATA;
}

unsigned char EEWrite(unsigned char ad, unsigned char val)
{
	EEADR = ad;
	EEDATA = val;
	EECON1bits.EEPGD = 0;
	EECON1bits.CFGS = 0;
	EECON1bits.WREN = 1;
	INTCONbits.GIE = 0;
	EECON2 = 0x55;
	EECON2 = 0xAA;
	EECON1bits.WR = 1;
	INTCONbits.GIE = 1;
	while(EECON1bits.WR);
	EECON1bits.WREN = 0;
}



unsigned char AttribuerUneFonction(unsigned char Precedente)
{
	unsigned char Fonction = FONCTIONS_AFFICHAGE_HEURE;

		if((Precedente == FONCTIONS_AFFICHAGE_HEURE) || (Precedente == FONCTIONS_AFFICHAGE_TEMPERATURE_INTERIEURE) || (Precedente == FONCTIONS_AFFICHAGE_TEMPERATURE_EXTERIEURE) || (Precedente == FONCTIONS_AFFICHAGE_VARIABLES))	/* Si la fonction qui est indique
																																																									comme tant active avant la dernire mise
																																																									hors tension est implmente */

		{
			Fonction = Precedente;
		}
		else
		{
			Fonction = FONCTIONS_AFFICHAGE_HEURE;
		}

	return Fonction;
}



void RecupererExtremes1(int * Minimale1, int * Maximale1)
{
	unsigned char L0;
	unsigned char L1;

	L1 = EERead(ADRESSE_MINIMUM_1);
	L0 = EERead(ADRESSE_MINIMUM_1 + 1);

	* Minimale1 = OctetsVersEntier(L1, L0);

	L1 = EERead(ADRESSE_MAXIMUM_1);
	L0 = EERead(ADRESSE_MAXIMUM_1 + 1);

	* Maximale1 = OctetsVersEntier(L1, L0);
}



void RecupererExtremes2(int * Minimale2, int * Maximale2)
{
	unsigned char L0;
	unsigned char L1;

	L1 = EERead(ADRESSE_MINIMUM_2);
	L0 = EERead(ADRESSE_MINIMUM_2 + 1);

	* Minimale2 = OctetsVersEntier(L1, L0);

	L1 = EERead(ADRESSE_MAXIMUM_2);
	L0 = EERead(ADRESSE_MAXIMUM_2 + 1);

	* Maximale2 = OctetsVersEntier(L1, L0);
}


void EnregistrerExtremes1(int Minimum1, int Maximum1)
{
	unsigned char L0;
	unsigned char L1;

	EntierVersOctets(Minimum1, &L1, &L0);

	EEWrite(ADRESSE_MINIMUM_1, L1);
	EEWrite((ADRESSE_MINIMUM_1 + 1), L0);

	EntierVersOctets(Maximum1, &L1, &L0);

	EEWrite(ADRESSE_MAXIMUM_1, L1);
	EEWrite((ADRESSE_MAXIMUM_1 + 1), L0);
}

void EnregistrerExtremes2(int Minimum2, int Maximum2)
{
	unsigned char L0;
	unsigned char L1;

	EntierVersOctets(Minimum2, &L1, &L0);

	EEWrite(ADRESSE_MINIMUM_2, L1);
	EEWrite((ADRESSE_MINIMUM_2 + 1), L0);

	EntierVersOctets(Maximum2, &L1, &L0);

	EEWrite(ADRESSE_MAXIMUM_2, L1);
	EEWrite((ADRESSE_MAXIMUM_2 + 1), L0);
}



unsigned char RecupererFonctionPrecedente(void)
{
	unsigned char Valeur = 0;

	Valeur = EERead(ADRESSE_FONCTIONNEMENT);

	if((Valeur != FONCTIONS_AFFICHAGE_HEURE) && (Valeur != FONCTIONS_AFFICHAGE_TEMPERATURE_INTERIEURE) && (Valeur != FONCTIONS_AFFICHAGE_TEMPERATURE_EXTERIEURE) && (Valeur != FONCTIONS_AFFICHAGE_VARIABLES))	/* Si la fonction qui est indique
																																																				comme tant active avant la dernire mise
																																																				hors tension n'est pas implmente */
	{
		EEWrite(ADRESSE_FONCTIONNEMENT, FONCTIONS_AFFICHAGE_HEURE);

		Valeur = FONCTIONS_AFFICHAGE_HEURE;
	}

	return Valeur;
}
