


#include "h/p18f4550.h"

#include <i2c.h>

#include "h/Affichages.h"
#include "h/I2C.h"
#include "h/MemorisationsEEPROM.h"
#include "h/Thermometre.h"
#include "h/Parametres.h"
#include "h/Utilitaires.h"






#pragma config BOR = ON
#pragma config MCLRE = OFF
#pragma config LVP = OFF
#pragma config PBADEN = OFF
#pragma config DEBUG = OFF
#pragma config FCMEN = OFF
#pragma config IESO = OFF
#pragma config PWRT = OFF
#pragma config WDT = OFF
#pragma config WDTPS = 1024
#pragma config LPT1OSC = OFF
#pragma config XINST = OFF
#pragma config STVREN = OFF 
#pragma config FOSC = INTOSCIO_EC



unsigned char g_Affichages[4] = {0x00};

unsigned char g_Points_1[4] = {0x00};
unsigned char g_Points_2[4] = {0x00};
unsigned char g_Points_3[4] = {0x00};

unsigned char g_Heures = 0;

unsigned char g_Minutes = 0;

unsigned char g_Secondes = 0;

unsigned char g_Fonction = 1;



void main(void)
{
	unsigned char k;

	unsigned char T1 = 0x00;

	unsigned char T2 = 0x00;

	unsigned char VariableExpanseurLecture = 0x00;

	unsigned char Lectures = 0x00;

	unsigned char Tampon = 0x00;

	unsigned char v;


	OSCCON = 0xFF;

	OSCTUNE = 0x00;

	CCP1CON = 0;

	ADCON1 = 0x0F; 
   
	T1CON = 0b10000000;



	INTCONbits.GIE = 0;	/* Desactivation gnrale des interruptions */

	INTCONbits.PEIE = 1;	/* Activation des interruptions des aux priphriques */

	INTCON3bits.INT2IE = 1;	/* Activation de l'interruption de  la broche  RB2 - INT . */

	PIE1bits.TMR1IE = 0;	/* Desactivation des interruptions des au module du TIMER1 */

	INTCON2bits.INTEDG2 = 0;	/* Configuration du dclenchement des interruptions des  la broche  RB2 - INT  sur front descendant */
	


	TRISA = 0x00;
	TRISB = 0x0F;
	TRISC = 0x00;
	TRISD = 0x00;
	TRISE = 0xFC;



	g_Affichages[3] = 0x00;	/* Heures, dizaines. */
	g_Affichages[2] = 0x77;	/* Heures, units. */
	g_Affichages[1] = 0x77;	/* Minutes, dizaines. */
	g_Affichages[0] = 0x77;	/* Minutes, units. */



	OpenI2C(MASTER, SLEW_OFF);



	SSPADD = 39;



	g_Secondes = 0;
	g_Minutes = 0;
	g_Heures = 0;
	
	
	
	Delai(3000);



	RecupererHeure();

	Tampon = RecupererFonctionPrecedente();

	g_Fonction = AttribuerUneFonction(Tampon);
	
	
	Write16court(ADRESSE_HORLOGE_TEMPS_REEL, 0x01, (OctetVersBCD(BCDVersOctet(Read16court(ADRESSE_HORLOGE_TEMPS_REEL, 0x01, (ADRESSE_HORLOGE_TEMPS_REEL | 0x01))))));
	Write(ADRESSE_EXPANSEUR_DE_PORTS, 0x8F);



	VariableExpanseurLecture = Read(ADRESSE_EXPANSEUR_DE_PORTS | 0x01);


	ConfigurerUnCapteur(ADRESSE_CAPTEUR_1);
	ConfigurerUnCapteur(ADRESSE_CAPTEUR_2);



	Write16court(ADRESSE_HORLOGE_TEMPS_REEL, 0x01, (OctetVersBCD(g_Minutes)));



	ChangerHeuresMinutes(g_Heures, g_Minutes);



	for(v = 0; v < (1 + g_Secondes); v++)
	{
		ChangerSecondes(0, v);
	}



	T1CONbits.TMR1ON = 0;	/* Dsactivation du module du TIMER1 */



	INTCONbits.GIE = 1;	/* Activation gnrale des interruptions */



	while(1)
	{
		ScrutationsMultiples(10, 3, 90);

		if(!((0x08 & PORTB) == 0x08))	/* Si l'appui d'un des boutons-poussoirs est constat, signal par une broche de l'expanseur de ports */
		{
			VariableExpanseurLecture = Read(ADRESSE_EXPANSEUR_DE_PORTS | 0x01);
		}
	}
}





#pragma interrupt InterruptHandler   
void InterruptHandler (void)
{
	unsigned short i;

	unsigned char b;

	unsigned char T1 = 0;
	unsigned char T2 = 0;

	unsigned char Lectures = 0x00;

	static unsigned char c = 0;



	if(INTCON3bits.INT2IE && INTCON3bits.INT2IF)
	{
		if(((0x08 & PORTB) == 0x08))	/* Si la source de l'interruption est le signal de sortie  2 Hz du diviseur de frquences */
		{
			if(c < 1)
			{
				c++;
			}
			else
			{
				ChangerHeuresMinutes(g_Heures, g_Minutes);

				ChangerSecondes(0, g_Secondes);



				if(IncrementerUneSeconde(g_Heures, g_Minutes, g_Secondes) == 1)
				{
					if((g_Fonction == FONCTIONS_AFFICHAGE_HEURE) || (g_Fonction == FONCTIONS_AFFICHAGE_VARIABLES))
					{
						ChangerHeuresMinutes(g_Heures, g_Minutes);
					}
				}
					
				switch(g_Fonction)
				{
					case FONCTIONS_AFFICHAGE_HEURE :
					{
						ChangerSecondes(0, g_Secondes);
						Write(ADRESSE_EXPANSEUR_DE_PORTS, 0x8F);

						break;
					}

					case FONCTIONS_AFFICHAGE_TEMPERATURE_INTERIEURE :
					{
						ChangerSecondes(1, 0);

						PORTA = 0x00;

						PORTB = 0x00;

						PORTC = 0x00;
						PORTD = 0x00;
						PORTE = 0x00;



						Read16nouvelle(ADRESSE_CAPTEUR_1, 0x00, (ADRESSE_CAPTEUR_1 | 0x01), &T1, &T2);
						AfficherUneTemperature(ENDROIT_AFFICHAGE_TEMPERATURE_INTERIEURE, T1, T2);

						break;
					}

					case FONCTIONS_AFFICHAGE_TEMPERATURE_EXTERIEURE :
					{
						ChangerSecondes(1, 0);

						PORTA = 0x00;

						PORTB = 0x00;

						PORTC = 0x00;
						PORTD = 0x00;
						PORTE = 0x00;

						Read16nouvelle(ADRESSE_CAPTEUR_2, 0x00, (ADRESSE_CAPTEUR_2 | 0x01), &T1, &T2);
						AfficherUneTemperature(ENDROIT_AFFICHAGE_TEMPERATURE_EXTERIEURE, T1, T2);

						break;
					}

					case FONCTIONS_AFFICHAGE_VARIABLES :
					{
						if((g_Secondes == 10) || (g_Secondes == 11) || (g_Secondes == 12) || (g_Secondes == 20) || (g_Secondes == 21) || (g_Secondes == 22) || (g_Secondes == 40) || (g_Secondes == 41) || (g_Secondes == 42) || (g_Secondes == 50) || (g_Secondes == 51) || (g_Secondes == 52))
						{
							if((g_Secondes == 10) || (g_Secondes == 11) || (g_Secondes == 12) || (g_Secondes == 40) || (g_Secondes == 41) || (g_Secondes == 42))
							{
								ChangerSecondes(1, 0);
	
								PORTA = 0x00;
		
								PORTB = 0x00;
		
								PORTC = 0x00;
								PORTD = 0x00;
								PORTE = 0x00;
		
		
		
								Read16nouvelle(ADRESSE_CAPTEUR_1, 0x00, (ADRESSE_CAPTEUR_1 | 0x01), &T1, &T2);
								AfficherUneTemperature(ENDROIT_AFFICHAGE_TEMPERATURE_INTERIEURE, T1, T2);
							}
	
							if((g_Secondes == 20) || (g_Secondes == 21) || (g_Secondes == 22) || (g_Secondes == 50) || (g_Secondes == 51) || (g_Secondes == 52))
							{
								ChangerSecondes(1, 0);
	
								PORTA = 0x00;
		
								PORTB = 0x00;
		
								PORTC = 0x00;
								PORTD = 0x00;
								PORTE = 0x00;
		
		
		
								Read16nouvelle(ADRESSE_CAPTEUR_2, 0x00, (ADRESSE_CAPTEUR_2 | 0x01), &T1, &T2);
								AfficherUneTemperature(ENDROIT_AFFICHAGE_TEMPERATURE_EXTERIEURE, T1, T2);
							}
						}
						else
						{
							if((g_Secondes == 13) || (g_Secondes == 23) || (g_Secondes == 43) || (g_Secondes == 53))
							{
								ChangerHeuresMinutes(g_Heures, g_Minutes);
								for(T1 = 0; T1 < (1 + g_Secondes); T1++)
								{
									ChangerSecondes(0, T1);
								}
							}
							ChangerSecondes(0, g_Secondes);
							Write(ADRESSE_EXPANSEUR_DE_PORTS, 0x8F);
						}

						break;
					}

					default :
					{
						g_Fonction = FONCTIONS_AFFICHAGE_HEURE;

						break;
					}
				}
				c = 0;
			}
			if(c == 1)
			{
				if((g_Fonction == FONCTIONS_AFFICHAGE_HEURE) || ((g_Fonction == FONCTIONS_AFFICHAGE_VARIABLES && (!((g_Secondes == 10) || (g_Secondes == 11) || (g_Secondes == 12) || (g_Secondes == 20) || (g_Secondes == 21) || (g_Secondes == 22) || (g_Secondes == 40) || (g_Secondes == 41) || (g_Secondes == 42) || (g_Secondes == 50) || (g_Secondes == 51) || (g_Secondes == 52))))))
				{
					Write(ADRESSE_EXPANSEUR_DE_PORTS, 0xBF);
				}
			}
		}
		else	/* Si la source de l'interruption est l'appui d'un des boutons-poussoirs, signal par une broche de l'expanseur de ports */
		{
			PORTB = 0x00;
			Delai(300);
			b = Read(ADRESSE_EXPANSEUR_DE_PORTS | 0x01);
			b = (0x07 & b);

			switch(b)
			{
				case 0x06 :	/* Si uniquement le bouton-poussoir des minutes a t appuy */
				{
					if(g_Fonction == FONCTIONS_AFFICHAGE_HEURE)
					{
						if(g_Minutes < 59)
						{
							g_Minutes++;
						}
						else
						{
							g_Minutes = 0;
						}
						g_Secondes = 0;
						ChangerSecondes(0, 0);
						Write16court(ADRESSE_HORLOGE_TEMPS_REEL, 0x00, 0x00);	/* Actualisation du chiffre
																				des secondes de l'horloge temps
																				rel  0 */
						Write16court(ADRESSE_HORLOGE_TEMPS_REEL, 0x01, (OctetVersBCD(g_Minutes)));	/* Actualisation du chiffre
																									des minutes de l'horloge temps rel  la
																									valeur qui corrspond au nouveau rglage */
					}
					break;
				}
				case 0x05 :	/* Si uniquement le bouton-poussoir des heures a t appuy */
				{
					if(g_Fonction == FONCTIONS_AFFICHAGE_HEURE)
					{
						if(g_Heures < 23)
						{
							g_Heures++;
						}
						else
						{
							g_Heures = 0;
						}
						Write16court(ADRESSE_HORLOGE_TEMPS_REEL, 0x02, (OctetVersBCD(g_Heures)));	/* Actualisation du chiffre
																			des heures de l'horloge temps rel  la
																			valeur qui corrspond au nouveau rglage */
					}
					break;
				}
				case 0x03 :	/* Si uniquement le bouton-poussoir de changement de fonction a t appuy */
				{
					if(g_Fonction < 4)
					{
						g_Fonction++;
					}
					else
					{
						g_Fonction = FONCTIONS_AFFICHAGE_HEURE;
						for(T1 = 0; T1 < (1 + g_Secondes); T1++)
						{
							ChangerSecondes(0, T1);
						}
					}
					EEWrite(ADRESSE_FONCTIONNEMENT, g_Fonction);
					break;
				}
				default :
				{
					break;
				}
			}
			if((g_Fonction == FONCTIONS_AFFICHAGE_HEURE) || (g_Fonction == FONCTIONS_AFFICHAGE_VARIABLES))
			{
				ChangerHeuresMinutes(g_Heures, g_Minutes);
				ChangerSecondes(0, g_Secondes);
			}
			while((0x04 & PORTB) == 0x00)	/* Bouclage tant que l'expanseur de ports signale
											qu'une de ses 8 broches a chang d'tat,
											depuis la dernire fois qu'il a t interrog */
			{
				Read(ADRESSE_EXPANSEUR_DE_PORTS | 0x01);
			}
		}

		INTCON3bits.INT2IF = 0;
	}
}



#pragma code InterruptVectorHigh = 0x08 
void InterruptVectorHigh(void)
{
    _asm
        goto InterruptHandler
    _endasm
}
 

